[Python-Dev] hg commit with diff -u output (was Re: hg extensions was Mercurial conversion repositories)
Barry Warsaw
barry at python.org
Sun Feb 27 03:21:07 CET 2011
FWIW, this modification to hgeditor does a reasonable approximation of 'bzr
commit' including the diff -u output.
Cheers,
-Barry
#!/bin/sh
#
# This is an example of using HGEDITOR to create of diff to review the
# changes while commiting.
# If you want to pass your favourite editor some other parameters
# only for Mercurial, modify this:
case "${EDITOR}" in
"")
EDITOR="sensible-editor"
;;
emacs)
EDITOR="$EDITOR -nw"
;;
gvim|vim)
EDITOR="$EDITOR -f -o"
;;
esac
HGTMP=""
cleanup_exit() {
rm -rf "$HGTMP"
}
# Remove temporary files even if we get interrupted
trap "cleanup_exit" 0 # normal exit
trap "exit 255" HUP INT QUIT ABRT TERM
HGTMP=$(mktemp -d ${TMPDIR-/tmp}/hgeditor.XXXXXX)
[ x$HGTMP != x -a -d $HGTMP ] || {
echo "Could not create temporary directory! Exiting." 1>&2
exit 1
}
(
grep '^HG: changed' "$1" | cut -b 13- | while read changed; do
"$HG" diff "$changed" >> "$HGTMP/diff"
done
)
cat "$1" > "$HGTMP/msg"
LINES=`wc -l $HGTMP/msg`
echo "" >> "$HGTMP/msg"
cat "$HGTMP/diff" >> "$HGTMP/msg"
MD5=$(which md5sum 2>/dev/null) || MD5=$(which md5 2>/dev/null)
[ -x "${MD5}" ] && CHECKSUM=`${MD5} "$HGTMP/msg"`
$EDITOR "$HGTMP/msg" || exit $?
if [ -x "${MD5}" ]
then
echo "$CHECKSUM" | ${MD5} -c >/dev/null 2>&1 && exit 13
fi
cat "$HGTMP/msg" | head -n $LINES > "$HGTMP/commit"
mv "$HGTMP/commit" "$1"
exit $?
-------------- next part --------------
A non-text attachment was scrubbed...
Name: signature.asc
Type: application/pgp-signature
Size: 836 bytes
Desc: not available
URL: <http://mail.python.org/pipermail/python-dev/attachments/20110226/5c7a18c9/attachment.pgp>
More information about the Python-Dev
mailing list